/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.51 from the
 * contents of GMP.xs. Do not edit this file, edit GMP.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "GMP.xs"
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"
#include "gmp.h"

typedef mpz_t mpz_t_ornull;

/* for Perl prior to v5.7.1 */
#ifndef SvUOK
#  define SvUOK(sv) SvIOK_UV(sv)
#endif

#ifndef PERL_UNUSED_ARG
#  define PERL_UNUSED_ARG(x) ((void)x)
#endif

#ifndef gv_stashpvs
#  define gv_stashpvs(name, create) gv_stashpvn(name, sizeof(name) - 1, create)
#endif

#ifndef PERL_MAGIC_ext
#  define PERL_MAGIC_ext '~'
#endif

#if defined(USE_ITHREADS) && defined(MGf_DUP)
#  define GMP_THREADSAFE 1
#else
#  define GMP_THREADSAFE 0
#endif

#ifdef sv_magicext
#  define GMP_HAS_MAGICEXT 1
#else
#  define GMP_HAS_MAGICEXT 0
#endif

#define NEW_GMP_MPZ_T      RETVAL = malloc (sizeof(mpz_t));
#define NEW_GMP_MPZ_T_INIT RETVAL = malloc (sizeof(mpz_t)); mpz_init(*RETVAL);
#define GMP_GET_ARG_0      TEMP = mpz_from_sv(x);
#define GMP_GET_ARG_1      TEMP_1 = mpz_from_sv(y);
#define GMP_GET_ARGS_0_1   GMP_GET_ARG_0; GMP_GET_ARG_1;

#if GMP_THREADSAFE
STATIC int
dup_gmp_mpz (pTHX_ MAGIC *mg, CLONE_PARAMS *params)
{
  mpz_t *RETVAL;
  PERL_UNUSED_ARG(params);
  NEW_GMP_MPZ_T;
  mpz_init_set(*RETVAL, *((mpz_t *)mg->mg_ptr));
  mg->mg_ptr = (char *)RETVAL;
  return 0;
}
#endif

#if GMP_HAS_MAGICEXT
STATIC MGVTBL vtbl_gmp = {
  NULL, /* get */
  NULL, /* set */
  NULL, /* len */
  NULL, /* clear */
  NULL, /* free */
# ifdef MGf_COPY
  NULL, /* copy */
# endif
# ifdef MGf_DUP
#  if GMP_THREADSAFE
  dup_gmp_mpz,
#  else
  NULL, /* dup */
#  endif
# endif
# ifdef MGf_LOCAL
  NULL, /* local */
# endif
};
#endif

STATIC void
attach_mpz_to_sv (SV *sv, mpz_t *mpz)
{
#if GMP_THREADSAFE
  MAGIC *mg;
#endif
#if !GMP_HAS_MAGICEXT
  SV *refaddr = sv_2mortal(newSViv(PTR2IV(mpz)));
#endif

  sv_bless(sv, gv_stashpvs("Math::BigInt::GMP", 0));

#if GMP_THREADSAFE && GMP_HAS_MAGICEXT
  mg =
#endif
#if GMP_HAS_MAGICEXT
    sv_magicext(SvRV(sv), NULL, PERL_MAGIC_ext, &vtbl_gmp, (void *)mpz, 0);
#else
  sv_magic(SvRV(sv), NULL, PERL_MAGIC_ext, (void *)refaddr, HEf_SVKEY);
#endif

#if GMP_THREADSAFE && GMP_HAS_MAGICEXT
  mg->mg_flags |= MGf_DUP;
#endif
}

STATIC SV *
sv_from_mpz (mpz_t *mpz)
{
  SV *sv = newSV(0);
  SV *obj = newRV_noinc(sv);

  attach_mpz_to_sv(obj, mpz);

  return obj;
}

STATIC mpz_t *
mpz_from_sv_nofail (SV *sv)
{
  MAGIC *mg;

  if (!sv_derived_from(sv, "Math::BigInt::GMP"))
    croak("not of type Math::BigInt::GMP");

  for (mg = SvMAGIC(SvRV(sv)); mg; mg = mg->mg_moremagic) {
    if (mg->mg_type == PERL_MAGIC_ext
#if GMP_HAS_MAGICEXT
        && mg->mg_virtual == &vtbl_gmp
#endif
        ) {
#if GMP_HAS_MAGICEXT
      return (mpz_t *)mg->mg_ptr;
#else
      return INT2PTR(mpz_t *, SvIV((SV *)mg->mg_ptr));
#endif
    }
  }

  return (mpz_t *)NULL;
}

STATIC mpz_t *
mpz_from_sv (SV *sv)
{
  mpz_t *mpz;

  if (!(mpz = mpz_from_sv_nofail(sv)))
    croak("failed to fetch mpz pointer");

  return mpz;
}

/*
Math::BigInt::GMP XS code, loosely based on Math::GMP, a Perl module for
high-speed arbitrary size integer calculations (C) 2000 James H. Turner
*/

#line 167 "GMP.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 311 "GMP.c"

XS_EUPXS(XS_Math__BigInt__GMP__new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__BigInt__GMP__new)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "Class, x");
    {
	SV*	x = ST(1)
;
	mpz_t *	RETVAL;
#line 168 "GMP.xs"
    NEW_GMP_MPZ_T;
    /* using the IV directly is a bit faster */
    if ((SvUOK(x) || SvIOK(x)) && (sizeof(UV) <= sizeof(unsigned long) || SvUV(x) == (unsigned long)SvUV(x)))
      {
      mpz_init_set_ui(*RETVAL, (unsigned long)SvUV(x));
      }
    else
      {
      mpz_init_set_str(*RETVAL, SvPV_nolen(x), 10);
      }
#line 334 "GMP.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_from_mpz(RETVAL);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__BigInt__GMP__new_attach); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__BigInt__GMP__new_attach)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "Class, sv, x");
    {
	SV *	sv = ST(1)
;
	SV *	x = ST(2)
;
#line 189 "GMP.xs"
    mpz_t *mpz;
#line 359 "GMP.c"
#line 191 "GMP.xs"
    mpz = malloc (sizeof(mpz_t));
    if ((SvUOK(x) || SvIOK(x)) && (sizeof(UV) <= sizeof(unsigned long) || SvUV(x) == (unsigned long)SvUV(x))) {
      mpz_init_set_ui(*mpz, (unsigned long)SvUV(x));
    }
    else {
      mpz_init_set_str(*mpz, SvPV_nolen(x), 10);
    }
    attach_mpz_to_sv(sv, mpz);
#line 369 "GMP.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Math__BigInt__GMP__from_bin); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__BigInt__GMP__from_bin)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "Class, x");
    {
	SV*	x = ST(1)
;
	mpz_t *	RETVAL;
#line 208 "GMP.xs"
    NEW_GMP_MPZ_T;
    mpz_init_set_str(*RETVAL, SvPV_nolen(x), 0);
#line 388 "GMP.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_from_mpz(RETVAL);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__BigInt__GMP__from_hex); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__BigInt__GMP__from_hex)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "Class, x");
    {
	SV*	x = ST(1)
;
	mpz_t *	RETVAL;
#line 221 "GMP.xs"
    NEW_GMP_MPZ_T;
    mpz_init_set_str(*RETVAL, SvPV_nolen(x), 0);
#line 413 "GMP.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_from_mpz(RETVAL);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__BigInt__GMP__from_oct); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__BigInt__GMP__from_oct)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "Class, x");
    {
	SV*	x = ST(1)
;
	mpz_t *	RETVAL;
#line 234 "GMP.xs"
    NEW_GMP_MPZ_T;
    mpz_init_set_str(*RETVAL, SvPV_nolen(x), 0);
#line 438 "GMP.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_from_mpz(RETVAL);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__BigInt__GMP__set); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__BigInt__GMP__set)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "Class, n, x");
    {
	mpz_t*        n = mpz_from_sv(ST(1))
;
	SV*	x = ST(2)
;
#line 248 "GMP.xs"
    mpz_init_set_ui(*n, SvIV(x));
#line 463 "GMP.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Math__BigInt__GMP__zero); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__BigInt__GMP__zero)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "Class");
    {
	mpz_t *	RETVAL;
#line 257 "GMP.xs"
    NEW_GMP_MPZ_T;
    mpz_init_set_ui(*RETVAL, 0);
#line 480 "GMP.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_from_mpz(RETVAL);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__BigInt__GMP__one); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__BigInt__GMP__one)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "Class");
    {
	mpz_t *	RETVAL;
#line 269 "GMP.xs"
    NEW_GMP_MPZ_T;
    mpz_init_set_ui(*RETVAL, 1);
#line 503 "GMP.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_from_mpz(RETVAL);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__BigInt__GMP__two); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__BigInt__GMP__two)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "Class");
    {
	mpz_t *	RETVAL;
#line 281 "GMP.xs"
    NEW_GMP_MPZ_T;
    mpz_init_set_ui(*RETVAL, 2);
#line 526 "GMP.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_from_mpz(RETVAL);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__BigInt__GMP__ten); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__BigInt__GMP__ten)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "Class");
    {
	mpz_t *	RETVAL;
#line 293 "GMP.xs"
    NEW_GMP_MPZ_T;
    mpz_init_set_ui(*RETVAL, 10);
#line 549 "GMP.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_from_mpz(RETVAL);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__BigInt__GMP__1ex); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__BigInt__GMP__1ex)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "Class, x");
    {
	int	x = (int)SvIV(ST(1))
;
	mpz_t *	RETVAL;
#line 306 "GMP.xs"
    NEW_GMP_MPZ_T;
    mpz_init_set_ui(*RETVAL, 10);
    mpz_pow_ui(*RETVAL, *RETVAL, x);
#line 575 "GMP.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_from_mpz(RETVAL);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__BigInt__GMP_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__BigInt__GMP_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "n");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	mpz_t_ornull*        n = mpz_from_sv_nofail(ST(0))
;
#line 320 "GMP.xs"
    if (n) {
        mpz_clear(*n);
        free(n);
    }
#line 603 "GMP.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__BigInt__GMP__str); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__BigInt__GMP__str)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "Class, n");
    {
	mpz_t*        n = mpz_from_sv(ST(1))
;
#line 332 "GMP.xs"
    int len;
    char *buf;
    char *buf_end;

#line 624 "GMP.c"
	SV *	RETVAL;
#line 337 "GMP.xs"
    /* len is always >= 1, and might be off (greater) by one than real len */
    len = mpz_sizeinbase(*n, 10);
    RETVAL = newSV(len);                /* alloc len +1 bytes */
    SvPOK_on(RETVAL);
    buf = SvPVX(RETVAL);                /* get ptr to storage */
    buf_end = buf + len - 1;            /* end of storage (-1)*/
    mpz_get_str(buf, 10, *n);           /* convert to decimal string */
    if (*buf_end == 0)
      {
      len --;                           /* got one shorter than expected */
      }
    SvCUR_set(RETVAL, len);             /* so set real length */
#line 639 "GMP.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__BigInt__GMP__len); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__BigInt__GMP__len)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "Class, n");
    {
	mpz_t*        n = mpz_from_sv(ST(1))
;
#line 359 "GMP.xs"
    char *buf;
    char *buf_end;

#line 660 "GMP.c"
	int	RETVAL;
	dXSTARG;
#line 363 "GMP.xs"
    /* len is always >= 1, and might be off (greater) by one than real len */
    RETVAL = mpz_sizeinbase(*n, 10);
    if (RETVAL > 1)                     /* is at least 10? */
      {
      New(0, buf, RETVAL + 1, I8);      /* alloc scratch buffer (len+1) bytes */
      buf_end = buf + RETVAL - 1;       /* end of storage (-1)*/
      mpz_get_str(buf, 10, *n);         /* convert to decimal string */
      if (*buf_end == 0)
        {
        RETVAL --;                      /* got one shorter than expected */
        }
      Safefree(buf);                    /* free the scratch buffer */
      }
#line 677 "GMP.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__BigInt__GMP__alen); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__BigInt__GMP__alen)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "Class, n");
    {
	mpz_t*        n = mpz_from_sv(ST(1))
;
	int	RETVAL;
	dXSTARG;
#line 387 "GMP.xs"
    /* len is always >= 1, and might be off (greater) by one than real len */
    RETVAL = mpz_sizeinbase(*n, 10);
#line 699 "GMP.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__BigInt__GMP__zeros); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__BigInt__GMP__zeros)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "Class, n");
    {
	mpz_t*        n = mpz_from_sv(ST(1))
;
#line 404 "GMP.xs"
    int len;
    char *buf;
    char *buf_end;

#line 721 "GMP.c"
	int	RETVAL;
	dXSTARG;
#line 409 "GMP.xs"
    /* odd numbers can not have trailing zeros */
    RETVAL = 1 - mpz_tstbit(*n,0);

    if (RETVAL != 0)                    /* was even */
      {
      /* len is always >= 1, and might be off (greater) by one than real len */
      RETVAL = 0;
      len = mpz_sizeinbase(*n, 10);
      if (len > 1)                      /* '0' has no trailing zeros! */
        {
        New(0, buf, len + 1, I8);
        mpz_get_str(buf, 10, *n);       /* convert to decimal string */
        buf_end = buf + len - 1;
        if (*buf_end == 0)              /* points to terminating zero? */
          {
          buf_end--;                    /* ptr to last real digit */
          len--;                        /* got one shorter than expected */
          }
        while (len-- > 0)               /* actually, we should hit a non-zero before the end */
          {
          if (*buf_end-- != '0')
            {
            break;
            }
          RETVAL++;
          }
        Safefree(buf);                  /* free the scratch buffer */
        }
      } /* end if n was even */
#line 754 "GMP.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__BigInt__GMP__to_hex); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__BigInt__GMP__to_hex)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "Class, n");
    {
	mpz_t *        n = mpz_from_sv(ST(1))
;
#line 449 "GMP.xs"
    int len;
    char *buf;

#line 775 "GMP.c"
	SV *	RETVAL;
#line 453 "GMP.xs"
    /* len is always >= 1, and accurate (unlike in decimal) */
    len = mpz_sizeinbase(*n, 16);
    RETVAL = newSV(len);                /* alloc len bytes */
    SvPOK_on(RETVAL);
    buf = SvPVX(RETVAL);                /* get ptr to storage */
    mpz_get_str(buf, 16, *n);           /* convert to hexadecimal string */
    SvCUR_set(RETVAL, len);             /* so set real length */
#line 785 "GMP.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__BigInt__GMP__to_bin); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__BigInt__GMP__to_bin)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "Class, n");
    {
	mpz_t *        n = mpz_from_sv(ST(1))
;
#line 471 "GMP.xs"
    int len;
    char *buf;

#line 806 "GMP.c"
	SV *	RETVAL;
#line 475 "GMP.xs"
    /* len is always >= 1, and accurate (unlike in decimal) */
    len = mpz_sizeinbase(*n, 2);
    RETVAL = newSV(len);                /* alloc len bytes */
    SvPOK_on(RETVAL);
    buf = SvPVX(RETVAL);                /* get ptr to storage */
    mpz_get_str(buf, 2, *n);            /* convert to binary string */
    SvCUR_set(RETVAL, len);             /* so set real length */
#line 816 "GMP.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__BigInt__GMP__to_oct); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__BigInt__GMP__to_oct)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "Class, n");
    {
	mpz_t *        n = mpz_from_sv(ST(1))
;
#line 493 "GMP.xs"
    int len;
    char *buf;

#line 837 "GMP.c"
	SV *	RETVAL;
#line 497 "GMP.xs"
    /* len is always >= 1, and accurate (unlike in decimal) */
    len = mpz_sizeinbase(*n, 8);
    RETVAL = newSV(len);                /* alloc len bytes */
    SvPOK_on(RETVAL);
    buf = SvPVX(RETVAL);                /* get ptr to storage */
    mpz_get_str(buf, 8, *n);            /* convert to octal string */
    SvCUR_set(RETVAL, len);             /* so set real length */
#line 847 "GMP.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__BigInt__GMP__as_hex); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__BigInt__GMP__as_hex)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "Class, n");
    {
	mpz_t *        n = mpz_from_sv(ST(1))
;
#line 515 "GMP.xs"
    int len;
    char *buf;

#line 868 "GMP.c"
	SV *	RETVAL;
#line 519 "GMP.xs"
    /* len is always >= 1, and accurate (unlike in decimal) */
    len = mpz_sizeinbase(*n, 16) + 2;
    RETVAL = newSV(len);                /* alloc len +1 (+2 for '0x') bytes */
    SvPOK_on(RETVAL);
    buf = SvPVX(RETVAL);                /* get ptr to storage */
    *buf++ = '0'; *buf++ = 'x';         /* prepend '0x' */
    mpz_get_str(buf, 16, *n);           /* convert to hexadecimal string */
    SvCUR_set(RETVAL, len);             /* so set real length */
#line 879 "GMP.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__BigInt__GMP__as_bin); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__BigInt__GMP__as_bin)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "Class, n");
    {
	mpz_t *        n = mpz_from_sv(ST(1))
;
#line 538 "GMP.xs"
    int len;
    char *buf;

#line 900 "GMP.c"
	SV *	RETVAL;
#line 542 "GMP.xs"
    /* len is always >= 1, and accurate (unlike in decimal) */
    len = mpz_sizeinbase(*n, 2) + 2;
    RETVAL = newSV(len);                /* alloc len +1 (+2 for '0b') bytes */
    SvPOK_on(RETVAL);
    buf = SvPVX(RETVAL);                /* get ptr to storage */
    *buf++ = '0'; *buf++ = 'b';         /* prepend '0b' */
    mpz_get_str(buf, 2, *n);            /* convert to binary string */
    SvCUR_set(RETVAL, len);             /* so set real length */
#line 911 "GMP.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__BigInt__GMP__as_oct); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__BigInt__GMP__as_oct)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "Class, n");
    {
	mpz_t *        n = mpz_from_sv(ST(1))
;
#line 561 "GMP.xs"
    int len;
    char *buf;

#line 932 "GMP.c"
	SV *	RETVAL;
#line 565 "GMP.xs"
    /* len is always >= 1, and accurate (unlike in decimal) */
    len = mpz_sizeinbase(*n, 8) + 1;
    RETVAL = newSV(len);                /* alloc len +1 (+1 for '0') bytes */
    SvPOK_on(RETVAL);
    buf = SvPVX(RETVAL);                /* get ptr to storage */
    *buf++ = '0';                       /* prepend '0' */
    mpz_get_str(buf, 8, *n);            /* convert to octal string */
    SvCUR_set(RETVAL, len);             /* so set real length */
#line 943 "GMP.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__BigInt__GMP__modpow); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__BigInt__GMP__modpow)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "Class, n, exp, mod");
    {
	mpz_t*        n = mpz_from_sv(ST(1))
;
	mpz_t*        exp = mpz_from_sv(ST(2))
;
	mpz_t*        mod = mpz_from_sv(ST(3))
;
	mpz_t *	RETVAL;
#line 586 "GMP.xs"
    NEW_GMP_MPZ_T_INIT;
    mpz_powm(*RETVAL, *n, *exp, *mod);
#line 968 "GMP.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_from_mpz(RETVAL);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__BigInt__GMP__modinv); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__BigInt__GMP__modinv)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "Class, x, y");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	mpz_t*        x = mpz_from_sv(ST(1))
;
	mpz_t*        y = mpz_from_sv(ST(2))
;
#line 606 "GMP.xs"
    int rc, sign;
    SV* s;
    mpz_t* RETVAL;
#line 997 "GMP.c"
#line 610 "GMP.xs"
    NEW_GMP_MPZ_T_INIT;
    rc = mpz_invert(*RETVAL, *x, *y);
    EXTEND(SP, 2);      /* we return two values */
    if (rc == 0)
      {
      /* Inverse doesn't exist. Return both values undefined. */
      PUSHs ( &PL_sv_undef );
      PUSHs ( &PL_sv_undef );
      mpz_clear(*RETVAL);
      free(RETVAL);
      }
    else
      {
      /* Inverse exists. When the modulus to mpz_invert() is positive,
       * the returned value is also positive. */
      PUSHs(sv_2mortal(sv_from_mpz(RETVAL)));
        s = sv_newmortal();
        sv_setpvn (s, "+", 1);
      PUSHs ( s );
      }
#line 1019 "GMP.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__BigInt__GMP__add); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__BigInt__GMP__add)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "Class, x, y");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV*	x = ST(1)
;
	SV*	y = ST(2)
;
#line 639 "GMP.xs"
        mpz_t* TEMP;
        mpz_t* TEMP_1;
#line 1042 "GMP.c"
#line 642 "GMP.xs"
    GMP_GET_ARGS_0_1;   /* (TEMP, TEMP_1) = (x,y)  */
    mpz_add(*TEMP, *TEMP, *TEMP_1);
    PUSHs( x );
#line 1047 "GMP.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__BigInt__GMP__inc); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__BigInt__GMP__inc)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "Class, x");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV*	x = ST(1)
;
#line 654 "GMP.xs"
        mpz_t* TEMP;
#line 1067 "GMP.c"
#line 656 "GMP.xs"
    GMP_GET_ARG_0;      /* TEMP =  mpz_t(x)  */
    mpz_add_ui(*TEMP, *TEMP, 1);
    PUSHs( x );
#line 1072 "GMP.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__BigInt__GMP__dec); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__BigInt__GMP__dec)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "Class, x");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV*	x = ST(1)
;
#line 667 "GMP.xs"
        mpz_t* TEMP;
#line 1092 "GMP.c"
#line 669 "GMP.xs"
    GMP_GET_ARG_0;      /* TEMP =  mpz_t(x)  */
    mpz_sub_ui(*TEMP, *TEMP, 1);
    PUSHs( x );
#line 1097 "GMP.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__BigInt__GMP__sub); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__BigInt__GMP__sub)
{
    dVAR; dXSARGS;
    if (items < 3)
       croak_xs_usage(cv,  "Class, x, y, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV*	x = ST(1)
;
	SV*	y = ST(2)
;
#line 689 "GMP.xs"
        mpz_t* TEMP;
        mpz_t* TEMP_1;
#line 1120 "GMP.c"
#line 692 "GMP.xs"
    GMP_GET_ARGS_0_1;   /* (TEMP, TEMP_1) = (x,y)  */
    if ( items == 4 && SvTRUE(ST(3)) )
      {
      /* y -= x */
      mpz_sub(*TEMP_1, *TEMP, *TEMP_1);
      PUSHs( y );
      }
    else
      {
      /* x -= y */
      mpz_sub(*TEMP, *TEMP, *TEMP_1);
      PUSHs( x );
      }
#line 1135 "GMP.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__BigInt__GMP__rsft); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__BigInt__GMP__rsft)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "Class, x, y, base_sv");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV*	x = ST(1)
;
	SV*	y = ST(2)
;
	SV*	base_sv = ST(3)
;
#line 715 "GMP.xs"
        unsigned long   y_ui;
        mpz_t*  TEMP;
        mpz_t*  TEMP_1;
        mpz_t*  BASE;

#line 1163 "GMP.c"
#line 721 "GMP.xs"
    GMP_GET_ARGS_0_1;   /* (TEMP, TEMP_1) = (x,y)  */

    y_ui = mpz_get_ui(*TEMP_1);
    BASE = malloc (sizeof(mpz_t));
    mpz_init_set_ui(*BASE,SvUV(base_sv));

    mpz_pow_ui(*BASE, *BASE, y_ui); /* ">> 3 in base 4" => "x / (4 ** 3)" */
    mpz_div(*TEMP, *TEMP, *BASE);
    mpz_clear(*BASE);
    free(BASE);
    PUSHs( x );
#line 1176 "GMP.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__BigInt__GMP__lsft); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__BigInt__GMP__lsft)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "Class, x, y, base_sv");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV*	x = ST(1)
;
	SV*	y = ST(2)
;
	SV*	base_sv = ST(3)
;
#line 742 "GMP.xs"
        unsigned long   y_ui;
        mpz_t*  TEMP;
        mpz_t*  TEMP_1;
        mpz_t*  BASE;

#line 1204 "GMP.c"
#line 748 "GMP.xs"
    GMP_GET_ARGS_0_1;   /* (TEMP, TEMP_1) = (x,y)  */

    y_ui = mpz_get_ui(*TEMP_1);
    BASE = malloc (sizeof(mpz_t));
    mpz_init_set_ui(*BASE,SvUV(base_sv));

    mpz_pow_ui(*BASE, *BASE, y_ui); /* "<< 3 in base 4" => "x * (4 ** 3)" */
    mpz_mul(*TEMP, *TEMP, *BASE);
    mpz_clear(*BASE);
    free(BASE);
    PUSHs ( x );
#line 1217 "GMP.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__BigInt__GMP__mul); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__BigInt__GMP__mul)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "Class, x, y");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV*	x = ST(1)
;
	SV*	y = ST(2)
;
#line 768 "GMP.xs"
        mpz_t* TEMP;
        mpz_t* TEMP_1;
#line 1240 "GMP.c"
#line 771 "GMP.xs"
    GMP_GET_ARGS_0_1;   /* (TEMP, TEMP_1) = (x,y)  */
    mpz_mul(*TEMP, *TEMP, *TEMP_1);
    PUSHs( x );
#line 1245 "GMP.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__BigInt__GMP__div); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__BigInt__GMP__div)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "Class, x, y");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV*	x = ST(1)
;
	SV*	y = ST(2)
;
#line 796 "GMP.xs"
    mpz_t* TEMP;
    mpz_t* TEMP_1;
    mpz_t * rem;
#line 1269 "GMP.c"
#line 800 "GMP.xs"
    GMP_GET_ARGS_0_1;   /* (TEMP, TEMP_1) = (x,y)  */
    if (GIMME_V == G_ARRAY)
      {
      /* former bdiv_two() routine */
      rem = malloc (sizeof(mpz_t));
      mpz_init(*rem);
      mpz_tdiv_qr(*TEMP, *rem, *TEMP, *TEMP_1);
      EXTEND(SP, 2);
      PUSHs( x );
      PUSHs(sv_2mortal(sv_from_mpz(rem)));
      }
    else
      {
      /* former div_two() routine */
      mpz_div(*TEMP, *TEMP, *TEMP_1);                   /* x /= y */
      PUSHs( x );
      }
#line 1288 "GMP.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__BigInt__GMP__mod); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__BigInt__GMP__mod)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "Class, x, y");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV*	x = ST(1)
;
	SV*	y = ST(2)
;
#line 826 "GMP.xs"
        mpz_t* TEMP;
        mpz_t* TEMP_1;
#line 1311 "GMP.c"
#line 829 "GMP.xs"
    GMP_GET_ARGS_0_1;   /* (TEMP, TEMP_1) = (x,y)  */
    mpz_mod(*TEMP, *TEMP, *TEMP_1);
    PUSHs( x );
#line 1316 "GMP.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__BigInt__GMP__acmp); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__BigInt__GMP__acmp)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "Class, m, n");
    {
	mpz_t *        m = mpz_from_sv(ST(1))
;
	mpz_t *        n = mpz_from_sv(ST(2))
;
	int	RETVAL;
	dXSTARG;
#line 842 "GMP.xs"
    RETVAL = mpz_cmp(*m, *n);
    if ( RETVAL < 0) { RETVAL = -1; }
    if ( RETVAL > 0) { RETVAL = 1; }
#line 1340 "GMP.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__BigInt__GMP__is_zero); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__BigInt__GMP__is_zero)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "Class, x");
    {
	mpz_t *        x = mpz_from_sv(ST(1))
;
	int	RETVAL;
	dXSTARG;
#line 856 "GMP.xs"
    RETVAL = mpz_cmp_ui(*x, 0);
    if ( RETVAL != 0) { RETVAL = 0; } else { RETVAL = 1; }
#line 1362 "GMP.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__BigInt__GMP__is_one); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__BigInt__GMP__is_one)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "Class, x");
    {
	mpz_t *        x = mpz_from_sv(ST(1))
;
	int	RETVAL;
	dXSTARG;
#line 869 "GMP.xs"
    RETVAL = mpz_cmp_ui(*x, 1);
    if ( RETVAL != 0) { RETVAL = 0; } else { RETVAL = 1; }
#line 1384 "GMP.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__BigInt__GMP__is_two); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__BigInt__GMP__is_two)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "Class, x");
    {
	mpz_t *        x = mpz_from_sv(ST(1))
;
	int	RETVAL;
	dXSTARG;
#line 882 "GMP.xs"
    RETVAL = mpz_cmp_ui(*x, 2);
    if ( RETVAL != 0) { RETVAL = 0; } else { RETVAL = 1; }
#line 1406 "GMP.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__BigInt__GMP__is_ten); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__BigInt__GMP__is_ten)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "Class, x");
    {
	mpz_t *        x = mpz_from_sv(ST(1))
;
	int	RETVAL;
	dXSTARG;
#line 895 "GMP.xs"
    RETVAL = mpz_cmp_ui(*x, 10);
    if ( RETVAL != 0) { RETVAL = 0; } else { RETVAL = 1; }
#line 1428 "GMP.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__BigInt__GMP__pow); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__BigInt__GMP__pow)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "Class, x, y");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV*	x = ST(1)
;
	SV*	y = ST(2)
;
#line 908 "GMP.xs"
        mpz_t* TEMP;
        mpz_t* TEMP_1;
#line 1452 "GMP.c"
#line 911 "GMP.xs"
    GMP_GET_ARGS_0_1;   /* (TEMP, TEMP_1) = (x,y)  */
    mpz_pow_ui(*TEMP, *TEMP, mpz_get_ui( *TEMP_1 ) );
    PUSHs( x );
#line 1457 "GMP.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__BigInt__GMP__lcm); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__BigInt__GMP__lcm)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "Class, x, y");
    {
	mpz_t*        x = mpz_from_sv(ST(1))
;
	mpz_t*        y = mpz_from_sv(ST(2))
;
	mpz_t *	RETVAL;
#line 924 "GMP.xs"
    NEW_GMP_MPZ_T_INIT;
    mpz_lcm(*RETVAL, *x, *y);
#line 1479 "GMP.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_from_mpz(RETVAL);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__BigInt__GMP__gcd); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__BigInt__GMP__gcd)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "Class, x, y");
    {
	mpz_t*        x = mpz_from_sv(ST(1))
;
	mpz_t*        y = mpz_from_sv(ST(2))
;
	mpz_t *	RETVAL;
#line 938 "GMP.xs"
    NEW_GMP_MPZ_T_INIT;
    mpz_gcd(*RETVAL, *x, *y);
#line 1506 "GMP.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_from_mpz(RETVAL);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__BigInt__GMP__nok); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__BigInt__GMP__nok)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "Class, x, y");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV*	x = ST(1)
;
	SV*	y = ST(2)
;
#line 951 "GMP.xs"
        mpz_t* TEMP;
        mpz_t* TEMP_1;
#line 1534 "GMP.c"
#line 954 "GMP.xs"
    GMP_GET_ARGS_0_1;   /* (TEMP, TEMP_1) = (x,y)  */
    mpz_bin_ui(*TEMP, *TEMP, mpz_get_ui(*TEMP_1));
    PUSHs( x );
#line 1539 "GMP.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__BigInt__GMP__fib); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__BigInt__GMP__fib)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "Class, x");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV*	x = ST(1)
;
#line 965 "GMP.xs"
        mpz_t* TEMP;
#line 1559 "GMP.c"
#line 967 "GMP.xs"
    GMP_GET_ARG_0;   /* TEMP = x */
    mpz_fib_ui(*TEMP, mpz_get_ui(*TEMP));
    PUSHs( x );
#line 1564 "GMP.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__BigInt__GMP__lucas); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__BigInt__GMP__lucas)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "Class, x");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV*	x = ST(1)
;
#line 978 "GMP.xs"
        mpz_t* TEMP;
#line 1584 "GMP.c"
#line 980 "GMP.xs"
    GMP_GET_ARG_0;   /* TEMP = x */
    mpz_lucnum_ui(*TEMP, mpz_get_ui(*TEMP));
    PUSHs( x );
#line 1589 "GMP.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__BigInt__GMP__and); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__BigInt__GMP__and)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "Class, x, y");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV*	x = ST(1)
;
	SV*	y = ST(2)
;
#line 992 "GMP.xs"
        mpz_t* TEMP;
        mpz_t* TEMP_1;
#line 1612 "GMP.c"
#line 995 "GMP.xs"
    GMP_GET_ARGS_0_1;   /* (TEMP, TEMP_1) = (x,y)  */
    mpz_and(*TEMP, *TEMP, *TEMP_1);
    PUSHs( x );
#line 1617 "GMP.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__BigInt__GMP__xor); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__BigInt__GMP__xor)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "Class, x, y");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV*	x = ST(1)
;
	SV*	y = ST(2)
;
#line 1008 "GMP.xs"
        mpz_t* TEMP;
        mpz_t* TEMP_1;
#line 1640 "GMP.c"
#line 1011 "GMP.xs"
    GMP_GET_ARGS_0_1;   /* (TEMP, TEMP_1) = (x,y)  */
    mpz_xor(*TEMP, *TEMP, *TEMP_1);
    PUSHs( x );
#line 1645 "GMP.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__BigInt__GMP__or); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__BigInt__GMP__or)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "Class, x, y");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV*	x = ST(1)
;
	SV*	y = ST(2)
;
#line 1024 "GMP.xs"
        mpz_t* TEMP;
        mpz_t* TEMP_1;
#line 1668 "GMP.c"
#line 1027 "GMP.xs"
    GMP_GET_ARGS_0_1;   /* (TEMP, TEMP_1) = (x,y)  */
    mpz_ior(*TEMP, *TEMP, *TEMP_1);
    PUSHs( x );
#line 1673 "GMP.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__BigInt__GMP__fac); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__BigInt__GMP__fac)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "Class, x");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV*	x = ST(1)
;
#line 1039 "GMP.xs"
        mpz_t* TEMP;
#line 1693 "GMP.c"
#line 1041 "GMP.xs"
    GMP_GET_ARG_0;   /* TEMP = x */
    mpz_fac_ui(*TEMP, mpz_get_ui(*TEMP));
    PUSHs( x );
#line 1698 "GMP.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__BigInt__GMP__dfac); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__BigInt__GMP__dfac)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "Class, x");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV*	x = ST(1)
;
#line 1053 "GMP.xs"
        mpz_t* TEMP;
#line 1718 "GMP.c"
#line 1055 "GMP.xs"
    GMP_GET_ARG_0;   /* TEMP = x */
    mpz_2fac_ui(*TEMP, mpz_get_ui(*TEMP));
    PUSHs( x );
#line 1723 "GMP.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__BigInt__GMP__copy); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__BigInt__GMP__copy)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "Class, m");
    {
	mpz_t*        m = mpz_from_sv(ST(1))
;
	mpz_t *	RETVAL;
#line 1068 "GMP.xs"
    NEW_GMP_MPZ_T;
    mpz_init_set(*RETVAL, *m);
#line 1743 "GMP.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_from_mpz(RETVAL);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__BigInt__GMP__is_odd); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__BigInt__GMP__is_odd)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "Class, n");
    {
	mpz_t*        n = mpz_from_sv(ST(1))
;
	int	RETVAL;
	dXSTARG;
#line 1082 "GMP.xs"
   RETVAL = mpz_tstbit(*n,0);
#line 1768 "GMP.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__BigInt__GMP__is_even); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__BigInt__GMP__is_even)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "Class, n");
    {
	mpz_t*        n = mpz_from_sv(ST(1))
;
	int	RETVAL;
	dXSTARG;
#line 1094 "GMP.xs"
     RETVAL = ! mpz_tstbit(*n,0);
#line 1789 "GMP.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__BigInt__GMP__sqrt); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__BigInt__GMP__sqrt)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "Class, x");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV*	x = ST(1)
;
#line 1105 "GMP.xs"
        mpz_t* TEMP;
#line 1810 "GMP.c"
#line 1107 "GMP.xs"
    GMP_GET_ARG_0;   /* TEMP = x */
    mpz_sqrt(*TEMP, *TEMP);
    PUSHs( x );
#line 1815 "GMP.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__BigInt__GMP__root); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__BigInt__GMP__root)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "Class, x, y");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV*	x = ST(1)
;
	SV*	y = ST(2)
;
#line 1120 "GMP.xs"
        mpz_t* TEMP;
        mpz_t* TEMP_1;
#line 1838 "GMP.c"
#line 1123 "GMP.xs"
    GMP_GET_ARGS_0_1;   /* (TEMP, TEMP_1) = (x,y)  */
    mpz_root(*TEMP, *TEMP, mpz_get_ui(*TEMP_1));
    PUSHs( x );
#line 1843 "GMP.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__BigInt__GMP_gmp_version); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__BigInt__GMP_gmp_version)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 1133 "GMP.xs"
        RETVAL = newSVpv(gmp_version, 0);

#line 1861 "GMP.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}

#ifdef __cplusplus
extern "C" {
#endif
XS_EXTERNAL(boot_Math__BigInt__GMP); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Math__BigInt__GMP)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if PERL_VERSION_LE(5, 8, 999) /* PERL_VERSION_LT is 5.33+ */
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        (void)newXSproto_portable("Math::BigInt::GMP::_new", XS_Math__BigInt__GMP__new, file, "$$");
        (void)newXSproto_portable("Math::BigInt::GMP::_new_attach", XS_Math__BigInt__GMP__new_attach, file, "$$$");
        (void)newXSproto_portable("Math::BigInt::GMP::_from_bin", XS_Math__BigInt__GMP__from_bin, file, "$$");
        (void)newXSproto_portable("Math::BigInt::GMP::_from_hex", XS_Math__BigInt__GMP__from_hex, file, "$$");
        (void)newXSproto_portable("Math::BigInt::GMP::_from_oct", XS_Math__BigInt__GMP__from_oct, file, "$$");
        (void)newXSproto_portable("Math::BigInt::GMP::_set", XS_Math__BigInt__GMP__set, file, "$$$");
        (void)newXSproto_portable("Math::BigInt::GMP::_zero", XS_Math__BigInt__GMP__zero, file, "$");
        (void)newXSproto_portable("Math::BigInt::GMP::_one", XS_Math__BigInt__GMP__one, file, "$");
        (void)newXSproto_portable("Math::BigInt::GMP::_two", XS_Math__BigInt__GMP__two, file, "$");
        (void)newXSproto_portable("Math::BigInt::GMP::_ten", XS_Math__BigInt__GMP__ten, file, "$");
        (void)newXSproto_portable("Math::BigInt::GMP::_1ex", XS_Math__BigInt__GMP__1ex, file, "$$");
        (void)newXSproto_portable("Math::BigInt::GMP::DESTROY", XS_Math__BigInt__GMP_DESTROY, file, "$");
        (void)newXSproto_portable("Math::BigInt::GMP::_str", XS_Math__BigInt__GMP__str, file, "$$");
        (void)newXSproto_portable("Math::BigInt::GMP::_len", XS_Math__BigInt__GMP__len, file, "$$");
        (void)newXSproto_portable("Math::BigInt::GMP::_alen", XS_Math__BigInt__GMP__alen, file, "$$");
        (void)newXSproto_portable("Math::BigInt::GMP::_zeros", XS_Math__BigInt__GMP__zeros, file, "$$");
        (void)newXSproto_portable("Math::BigInt::GMP::_to_hex", XS_Math__BigInt__GMP__to_hex, file, "$$");
        (void)newXSproto_portable("Math::BigInt::GMP::_to_bin", XS_Math__BigInt__GMP__to_bin, file, "$$");
        (void)newXSproto_portable("Math::BigInt::GMP::_to_oct", XS_Math__BigInt__GMP__to_oct, file, "$$");
        (void)newXSproto_portable("Math::BigInt::GMP::_as_hex", XS_Math__BigInt__GMP__as_hex, file, "$$");
        (void)newXSproto_portable("Math::BigInt::GMP::_as_bin", XS_Math__BigInt__GMP__as_bin, file, "$$");
        (void)newXSproto_portable("Math::BigInt::GMP::_as_oct", XS_Math__BigInt__GMP__as_oct, file, "$$");
        (void)newXSproto_portable("Math::BigInt::GMP::_modpow", XS_Math__BigInt__GMP__modpow, file, "$$$$");
        (void)newXSproto_portable("Math::BigInt::GMP::_modinv", XS_Math__BigInt__GMP__modinv, file, "$$$");
        (void)newXSproto_portable("Math::BigInt::GMP::_add", XS_Math__BigInt__GMP__add, file, "$$$");
        (void)newXSproto_portable("Math::BigInt::GMP::_inc", XS_Math__BigInt__GMP__inc, file, "$$");
        (void)newXSproto_portable("Math::BigInt::GMP::_dec", XS_Math__BigInt__GMP__dec, file, "$$");
        (void)newXSproto_portable("Math::BigInt::GMP::_sub", XS_Math__BigInt__GMP__sub, file, "$$$;@");
        (void)newXSproto_portable("Math::BigInt::GMP::_rsft", XS_Math__BigInt__GMP__rsft, file, "$$$$");
        (void)newXSproto_portable("Math::BigInt::GMP::_lsft", XS_Math__BigInt__GMP__lsft, file, "$$$$");
        (void)newXSproto_portable("Math::BigInt::GMP::_mul", XS_Math__BigInt__GMP__mul, file, "$$$");
        (void)newXSproto_portable("Math::BigInt::GMP::_div", XS_Math__BigInt__GMP__div, file, "$$$");
        (void)newXSproto_portable("Math::BigInt::GMP::_mod", XS_Math__BigInt__GMP__mod, file, "$$$");
        (void)newXSproto_portable("Math::BigInt::GMP::_acmp", XS_Math__BigInt__GMP__acmp, file, "$$$");
        (void)newXSproto_portable("Math::BigInt::GMP::_is_zero", XS_Math__BigInt__GMP__is_zero, file, "$$");
        (void)newXSproto_portable("Math::BigInt::GMP::_is_one", XS_Math__BigInt__GMP__is_one, file, "$$");
        (void)newXSproto_portable("Math::BigInt::GMP::_is_two", XS_Math__BigInt__GMP__is_two, file, "$$");
        (void)newXSproto_portable("Math::BigInt::GMP::_is_ten", XS_Math__BigInt__GMP__is_ten, file, "$$");
        (void)newXSproto_portable("Math::BigInt::GMP::_pow", XS_Math__BigInt__GMP__pow, file, "$$$");
        (void)newXSproto_portable("Math::BigInt::GMP::_lcm", XS_Math__BigInt__GMP__lcm, file, "$$$");
        (void)newXSproto_portable("Math::BigInt::GMP::_gcd", XS_Math__BigInt__GMP__gcd, file, "$$$");
        (void)newXSproto_portable("Math::BigInt::GMP::_nok", XS_Math__BigInt__GMP__nok, file, "$$$");
        (void)newXSproto_portable("Math::BigInt::GMP::_fib", XS_Math__BigInt__GMP__fib, file, "$$");
        (void)newXSproto_portable("Math::BigInt::GMP::_lucas", XS_Math__BigInt__GMP__lucas, file, "$$");
        (void)newXSproto_portable("Math::BigInt::GMP::_and", XS_Math__BigInt__GMP__and, file, "$$$");
        (void)newXSproto_portable("Math::BigInt::GMP::_xor", XS_Math__BigInt__GMP__xor, file, "$$$");
        (void)newXSproto_portable("Math::BigInt::GMP::_or", XS_Math__BigInt__GMP__or, file, "$$$");
        (void)newXSproto_portable("Math::BigInt::GMP::_fac", XS_Math__BigInt__GMP__fac, file, "$$");
        (void)newXSproto_portable("Math::BigInt::GMP::_dfac", XS_Math__BigInt__GMP__dfac, file, "$$");
        (void)newXSproto_portable("Math::BigInt::GMP::_copy", XS_Math__BigInt__GMP__copy, file, "$$");
        (void)newXSproto_portable("Math::BigInt::GMP::_is_odd", XS_Math__BigInt__GMP__is_odd, file, "$$");
        (void)newXSproto_portable("Math::BigInt::GMP::_is_even", XS_Math__BigInt__GMP__is_even, file, "$$");
        (void)newXSproto_portable("Math::BigInt::GMP::_sqrt", XS_Math__BigInt__GMP__sqrt, file, "$$");
        (void)newXSproto_portable("Math::BigInt::GMP::_root", XS_Math__BigInt__GMP__root, file, "$$$");
        (void)newXSproto_portable("Math::BigInt::GMP::gmp_version", XS_Math__BigInt__GMP_gmp_version, file, "");
#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

#ifdef __cplusplus
}
#endif
